=== modified file 'MANIFEST.in'
--- MANIFEST.in	2007-03-26 06:08:50 +0000
+++ MANIFEST.in	2006-12-24 06:43:14 +0000
@@ -1,4 +1,4 @@
-include dev.cfg loggerhead.conf.example README.txt NEWS
+include dev.cfg loggerhead.conf
 recursive-include loggerhead/templates *.kid
 recursive-include loggerhead/config *.cfg
 recursive-include loggerhead/static *

=== removed file 'NEWS'
--- NEWS	2007-05-21 06:19:12 +0000
+++ NEWS	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-
-What's changed in loggerhead?
-=============================
-
-1.1.1  [24jan2007]
-------------------
-
-    - fix broken inventory page (oops!)
-    
-    - fix a few rendering problems with kid and safari
-
-
-1.1  [20jan2007]
-----------------
-
-    - new feature to compare two revisions to each other
-    
-    - inserted text in diffs is now blue instead of green
-    
-    - fixed to start and stop as a daemon now (use "-f" to run in the
-      foreground), and all config is in loggerhead.conf (no need to mess with
-      dev.cfg)
-      
-    - renamed show/hide javascript buttons to expand/collapse, and made them
-      much faster
-      
-    - added an atom-feed link to each branch on the browse page [elliot
-      murphy]
-      
-    - auto-publish feature for multiple branches under a single folder (see
-      loggerhead.conf.example)
-      
-    - added the ability to share cache files per-project instead of just
-      per-branch
-    
-    - added side-by-side diff display for the revision page (which is the
-      default), with a button to switch between side-by-side and unified diff
-      format
-
-    - made caching use file locking, and close cleanly on shutdown
-    
-    - miscellaneous speed and page-size improvements
-
-
-1.0  [23dec2006]
-----------------
-
-    - initial release
-

=== modified file 'README.txt'
--- README.txt	2007-01-24 19:29:58 +0000
+++ README.txt	2007-01-14 05:40:40 +0000
@@ -1,7 +1,7 @@
 LOGGERHEAD
 ==========
 
-[ version 1.1.1 for bazaar 0.13 ]
+[ version 1.0 for bazaar 0.13 ]
 
 Loggerhead is a web viewer for bazaar branches.  It can be used to navigate
 a branch history, annotate files, perform searches... all the usual things.

=== removed file 'homepage/download/loggerhead-1.1-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.1-0.13.tar.gz and homepage/download/loggerhead-1.1-0.13.tar.gz differ
=== removed file 'homepage/download/loggerhead-1.1.1-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.1.1-0.13.tar.gz and homepage/download/loggerhead-1.1.1-0.13.tar.gz differ
=== modified file 'homepage/index.html'
--- homepage/index.html	2007-01-24 23:39:39 +0000
+++ homepage/index.html	2006-12-29 02:24:03 +0000
@@ -25,30 +25,13 @@
     in python 2.4.
     </p>
     
-    <h2> News </h2>
-    
-    <ul>
-    <li> <span class="date"> 24 Jan 2007 </span> <br>
-        Loggerhead 1.1.1 released, to fix a paper-bag bug and a couple of
-        rendering quirks. </li>
-    <li> <span class="date"> 20 Jan 2007 </span> <br>
-        Loggerhead 1.1 released, with a lot of new features and improvements.
-        </li>
-    </ul>
-    
     <h2> Download </h2>
     
-    <p>
-    The current version is 1.1.1-0.13 (meaning 1.1.1, requiring bazaar 0.13),
-    released on 24 Jan 2006 at revision 109.
+	<p>
+	The current version is 1.0-0.13 (meaning 1.0, based on bazaar 0.13),
+	released on 23 Dec 2006 at revision 64.
     </p>
     <ul class="downloads">
-    <li> <a href="download/loggerhead-1.1.1-0.13.tar.gz"> loggerhead-1.1.1-0.13.tar.gz </a>
-        <br /> <span class="md5"> MD5: 288af4396620443b7f2acd96a62ffbbf </span>
-        </li>
-    <li> <a href="download/loggerhead-1.1-0.13.tar.gz"> loggerhead-1.1-0.13.tar.gz </a>
-        <br /> <span class="md5"> MD5: 26194d00c72dbcaf63d14d9d099ee91e </span>
-        </li>
     <li> <a href="download/loggerhead-1.0-0.13.tar.gz"> loggerhead-1.0-0.13.tar.gz </a>
         <br /> <span class="md5"> MD5: 1b68c1dc6e13f9ed8f2b3ff0267cd8d9 </span>
         </li>
@@ -59,16 +42,17 @@
     <ul>
     <li> project page on launchpad (for bug reports): <br />
     <a class="link" href="https://launchpad.net/products/loggerhead/"> https://launchpad.net/products/loggerhead/ </a>
-    </li>
-
-    <li> development branch in bazaar: <br />
-    <a class="link" href="http://www.lag.net/robey/code/loggerhead/"> http://www.lag.net/robey/code/loggerhead/ </a>
-    </li>
-
-    <li> browse the source in loggerview: <br />
-    <a class="link" href="http://www.lag.net/branches/loggerhead/loggerhead_dev/"> http://www.lag.net/branches/loggerhead/loggerhead_dev/ </a>
-    </li>
-    </ul>	
+	</li>
+	
+	<li> development branch in bazaar: <br />
+	<a class="link" href="http://www.lag.net/~robey/code/loggerhead/"> http://www.lag.net/~robey/code/loggerhead/ </a>
+	</li>
+	
+	<li> browse the source in loggerview: <br />
+	<a class="link" href="http://www.lag.net/branches/loggerhead/loggerhead_dev/"> http://www.lag.net/branches/loggerhead/loggerhead_dev/ </a>
+	</li>
+	</ul>
+	
     
 </body>
 </html>

=== modified file 'homepage/loggerhead.css'
--- homepage/loggerhead.css	2007-01-24 23:39:39 +0000
+++ homepage/loggerhead.css	2006-12-24 06:54:21 +0000
@@ -42,9 +42,3 @@
 .link {
 	margin-left: 1em;
 }
-
-.date {
-    font-weight: bold;
-    font-size: smaller;
-    text-decoration: underline;
-}

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2007-06-18 23:07:53 +0000
+++ loggerhead.conf.example	2007-01-14 05:40:40 +0000
@@ -12,9 +12,6 @@
 # if you want a special title on the front page, set it here:
 title = 'branches in loggerhead'
 
-# the access and debug logs can be set up to roll 'daily', 'weekly', or 'never':
-log.roll = 'weekly'
-
 # group branches by project:
 [bazaar]
 

=== modified file 'loggerhead/TODO'
--- loggerhead/TODO	2007-05-21 06:19:31 +0000
+++ loggerhead/TODO	2007-01-08 07:06:06 +0000
@@ -6,15 +6,15 @@
 
 * potentially do a 'bzr pull' on a branch on an interval timer
 
+* it would be cool to view 1 revision relative to another base, and view the
+  diff & download the bundle for that
+
+* maybe change "changes" to "history"?  -- asked on bazaar-dev@ for opinions.
+
 * browse view: sort by name, last change?
 
 * something is leaking on www.lag.net/branches
 
-* download tar archive of revision?
-
-* nicholas allen suggested the ability to change the # of context lines
-  in diffs (probably something inside bzrlib) and also the ability to see
-  an entire file in diff format
-
-* setup.py install doesn't work
-
+* better logging
+
+* fix diff-key and buttons (look terrible)

=== modified file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2007-03-06 04:27:05 +0000
+++ loggerhead/branchview.py	2007-01-02 07:17:25 +0000
@@ -23,7 +23,6 @@
 import logging
 import posixpath
 import threading
-import urllib
 
 import turbogears
 from cherrypy import HTTPRedirect
@@ -118,7 +117,7 @@
         if url is not None:
             return posixpath.join(url, self._folder) + '/'
         # try branch-specific config?
-        url = self.get_history().get_config().get_user_option('public_branch')
+        url = self.get_history().get_config().get_user_option('public_url')
         return url
         
     branch_url = property(_get_branch_url)
@@ -161,7 +160,6 @@
             elements = [elements]
         if elements[0].startswith('/'):
             elements[0] = elements[0][1:]
-        elements = [urllib.quote(x) for x in elements]
         return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
 
     def last_updated(self):

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2007-06-04 21:16:03 +0000
+++ loggerhead/changecache.py	2007-01-08 00:00:26 +0000
@@ -87,33 +87,32 @@
         else:
             cache = shelve.open(self._changes_filename, 'c', protocol=2)
 
-        try:
-            out = []
-            fetch_list = []
-            sfetch_list = []
-            for revid in revid_list:
-                # if the revid is in unicode, use the utf-8 encoding as the key
-                srevid = util.to_utf8(revid)
-                
-                if srevid in cache:
-                    out.append(cache[srevid])
-                else:
-                    #self.log.debug('Entry cache miss: %r' % (revid,))
-                    out.append(None)
-                    fetch_list.append(revid)
-                    sfetch_list.append(srevid)
+        out = []
+        fetch_list = []
+        sfetch_list = []
+        for revid in revid_list:
+            # if the revid is in unicode, use the utf-8 encoding as the key
+            srevid = util.to_utf8(revid)
             
-            if len(fetch_list) > 0:
-                # some revisions weren't in the cache; fetch them
-                changes = self.history.get_changes_uncached(fetch_list, get_diffs)
-                if changes is None:
-                    return changes
-                for i in xrange(len(revid_list)):
-                    if out[i] is None:
-                        cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
-            return out
-        finally:
-            cache.close()
+            if srevid in cache:
+                out.append(cache[srevid])
+            else:
+                #self.log.debug('Entry cache miss: %r' % (revid,))
+                out.append(None)
+                fetch_list.append(revid)
+                sfetch_list.append(srevid)
+        
+        if len(fetch_list) > 0:
+            # some revisions weren't in the cache; fetch them
+            changes = self.history.get_changes_uncached(fetch_list, get_diffs)
+            if changes is None:
+                return changes
+            for i in xrange(len(revid_list)):
+                if out[i] is None:
+                    cache[sfetch_list.pop(0)] = out[i] = changes.pop(0)
+        
+        cache.close()
+        return out
     
     @with_lock
     def full(self, get_diffs=False):

=== modified file 'loggerhead/controllers/__init__.py'
--- loggerhead/controllers/__init__.py	2007-06-18 23:07:53 +0000
+++ loggerhead/controllers/__init__.py	2007-01-14 05:40:40 +0000
@@ -25,7 +25,7 @@
 
 import turbogears
 from turbogears import controllers
-from cherrypy import NotFound
+from cherrypy import HTTPRedirect, NotFound
 from configobj import ConfigObj
 
 from loggerhead import util
@@ -52,40 +52,24 @@
         
         self._views = []
         for view_name in config.sections:
-            log.debug('Configuring (project %s) branch %s...', name, view_name)
+            log.debug('Configuring (project %r) branch %r...', name, view_name)
             self._add_view(view_name, config[view_name], config[view_name].get('folder'))
         
-        self._auto_folder = config.get('auto_publish_folder', None)
-        self._auto_list = []
-        if self._auto_folder is not None:
-            self._recheck_auto_folders()
+        auto_folder = config.get('auto_publish_folder', None)
+        if auto_folder is not None:
+            auto_list = []
+            # scan a folder for bazaar branches, and add them automatically
+            for path, folders, filenames in os.walk(auto_folder):
+                for folder in folders:
+                    folder = os.path.join(path, folder)
+                    if is_branch(folder):
+                        auto_list.append(folder)
+            auto_list.sort()
+            for folder in auto_list:
+                view_name = os.path.basename(folder)
+                log.debug('Auto-configuring (project %r) branch %r...', name, view_name)
+                self._add_view(view_name, ConfigObj(), folder)
     
-    def _recheck_auto_folders(self):
-        log.debug('recheck...')
-        if self._auto_folder is None:
-            return
-        auto_list = []
-        # scan a folder for bazaar branches, and add them automatically
-        for path, folders, filenames in os.walk(self._auto_folder):
-            for folder in folders:
-                folder = os.path.join(path, folder)
-                if is_branch(folder):
-                    auto_list.append(folder)
-        auto_list.sort()
-        if auto_list == self._auto_list:
-            # nothing has changed; do nothing.
-            log.debug('ok')
-            return
-
-        # rebuild views:
-        log.debug('Rescanning auto-folder for project %s ...', self.name)
-        self._views = []
-        for folder in auto_list:
-            view_name = os.path.basename(folder)
-            log.debug('Auto-configuring (project %s) branch %s...', self.name, view_name)
-            self._add_view(view_name, ConfigObj(), folder)
-        self._auto_list = auto_list
-        
     def _add_view(self, view_name, view_config, folder):
         c_view_name = cherrypy_friendly(view_name)
         view = BranchView(self.name, c_view_name, view_name, folder, view_config, self._config)
@@ -96,25 +80,21 @@
 
 
 class Root (controllers.RootController):
-    def __init__(self, config):
+    def __init__(self):
         self._projects = []
-        self._config = config
-        for project_name in self._config.sections:
+        for project_name in sys._loggerhead_config.sections:
             c_project_name = cherrypy_friendly(project_name)
-            project = Project(c_project_name, self._config[project_name])
+            project = Project(c_project_name, sys._loggerhead_config[project_name])
             self._projects.append(project)
             setattr(self, c_project_name, project)
         
     @turbogears.expose(template='loggerhead.templates.browse')
     def index(self):
-        for p in self._projects:
-            p._recheck_auto_folders()
-        log.debug('%r' % {
+        return {
             'projects': self._projects,
             'util': util,
-            'title': self._config.get('title', ''),
-        })
-        return {}
+            'title': sys._loggerhead_config.get('title', ''),
+        }
 
     def _check_rebuild(self):
         for p in self._projects:
@@ -122,6 +102,9 @@
                 v.check_rebuild()
 
 
+# singleton:
+Root = Root()
+
 
 # for use in profiling the very-slow get_change() method:
 #h = Root.bazaar.bzr_dev.get_history()

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2007-05-21 07:37:15 +0000
+++ loggerhead/controllers/annotate_ui.py	2006-12-20 09:29:42 +0000
@@ -25,7 +25,7 @@
 import time
 
 import turbogears
-from cherrypy import HTTPError, InternalError, session
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -46,41 +46,31 @@
         self._branch = branch
         self.log = branch.log
 
-    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.annotate')
     def default(self, *args, **kw):
         z = time.time()
         h = self._branch.get_history()
-        util.set_context(kw)
         
         if len(args) > 0:
             revid = h.fix_revid(args[0])
         else:
             revid = None
-        path = None
-        if len(args) > 1:
-            path = '/'.join(args[1:])
-            if not path.startswith('/'):
-                path = '/' + path
         
         file_id = kw.get('file_id', None)
-        if (file_id is None) and (path is None):
-            raise HTTPError(400, 'No file_id or filename provided to annotate')
-
         if file_id is None:
-            file_id = h.get_file_id(revid, path)
+            raise HTTPRedirect(self._branch.url('/changes'))
 
         try:
             revid_list, revid = h.get_file_view(revid, file_id)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
             
         # no navbar for revisions
         navigation = util.Container()
         
-        if path is None:
-            path = h.get_path(revid, file_id)
+        path = h.get_path(revid, file_id)
         filename = os.path.basename(path)
 
         vals = {

=== modified file 'loggerhead/controllers/atom_ui.py'
--- loggerhead/controllers/atom_ui.py	2007-03-29 06:55:55 +0000
+++ loggerhead/controllers/atom_ui.py	2006-12-20 21:17:53 +0000
@@ -39,10 +39,12 @@
         entries = list(h.get_changes(list(revid_list)[:pagesize]))
 
         vals = {
+            'external_url': cherrypy.request.base,
             'branch': self._branch,
             'changes': entries,
             'util': util,
             'history': h,
+            'scan_url': '/changes',
             'updated': entries[0].date.isoformat() + 'Z',
         }
         h.flush_cache()

=== modified file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	2007-03-14 06:10:22 +0000
+++ loggerhead/controllers/bundle_ui.py	2006-12-20 22:00:14 +0000
@@ -20,7 +20,7 @@
 import time
 
 import turbogears
-from cherrypy import HTTPRedirect, InternalError, response
+from cherrypy import HTTPRedirect, response
 
 from loggerhead import util
 
@@ -37,20 +37,17 @@
         # /bundle/<rev_id>/filename
         z = time.time()
         h = self._branch.get_history()
-        compare_revid = kw.get('compare_revid', None)
 
         if len(args) < 1:
             raise HTTPRedirect(self._branch.url('/changes'))
         revid = h.fix_revid(args[0])
-        compare_revid = None
-        if len(args) >= 3:
-            compare_revid = h.fix_revid(args[1])
 
         try:
-            bundle_data = h.get_bundle(revid, compare_revid)
-        except:
-            self.log.exception('Exception fetching bundle')
-            raise InternalError('Could not fetch bundle')
+            bundle_data = h.get_bundle(revid)
+        except Exception, x:
+            self.log.error('Exception fetching bundle: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
             
         response.headers['Content-Type'] = 'text/plain'
         response.headers['Content-Length'] = len(bundle_data)

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2007-03-14 06:10:22 +0000
+++ loggerhead/controllers/changelog_ui.py	2006-12-24 07:02:43 +0000
@@ -21,11 +21,27 @@
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
 
+# just thinking out loud here...
+#
+# so, when browsing around, there are 3 pieces of context:
+#     - starting revid 
+#         the current beginning of navigation (navigation continues back to
+#         the original revision) -- this may not be along the primary revision
+#         path since the user may have navigated into a branch
+#     - file_id
+#         if navigating the revisions that touched a file
+#     - current revid
+#         current location along the navigation path (while browsing)
+#
+# current revid is given on the url path.  'file_id' and 'starting revid' are
+# handed along as params.
+
+
 class ChangeLogUI (object):
     
     def __init__(self, branch):
@@ -33,7 +49,6 @@
         self._branch = branch
         self.log = branch.log
         
-    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.changelog')
     def default(self, *args, **kw):
         z = time.time()
@@ -54,9 +69,6 @@
         
         try:
             revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
-            kw['start_revid'] = start_revid
-            util.set_context(kw)
-            
             if (query is not None) and (len(revid_list) == 0):
                 search_failed = True
 
@@ -66,9 +78,10 @@
                 scan_list = revid_list[h.get_revid_sequence(revid_list, revid):]
             entry_list = scan_list[:pagesize]
             entries = h.get_changes(entry_list)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
 
         navigation = util.Container(pagesize=pagesize, revid=revid, start_revid=start_revid, revid_list=revid_list,
                                     file_id=file_id, scan_url='/changes', branch=self._branch, feed=True)

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2007-01-24 19:26:27 +0000
+++ loggerhead/controllers/download_ui.py	2006-12-20 09:29:42 +0000
@@ -52,12 +52,11 @@
         
         revid = h.fix_revid(args[0])
         file_id = args[1]
-        path, filename, content = h.get_file(file_id, revid)
+        filename, content = h.get_file(file_id, revid)
         mime_type, encoding = mimetypes.guess_type(filename)
         if mime_type is None:
             mime_type = 'application/octet-stream'
-
-        self.log.info('/download %s @ %s (%d bytes)', path, h.get_revno(revid), len(content))
+        
         response.headers['Content-Type'] = mime_type
         response.headers['Content-Length'] = len(content)
         response.body = content

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2007-03-14 06:10:22 +0000
+++ loggerhead/controllers/inventory_ui.py	2006-12-20 09:29:42 +0000
@@ -25,7 +25,7 @@
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -46,12 +46,10 @@
         self._branch = branch
         self.log = branch.log
 
-    @util.strip_whitespace
     @turbogears.expose(html='loggerhead.templates.inventory')
     def default(self, *args, **kw):
         z = time.time()
         h = self._branch.get_history()
-        util.set_context(kw)
         
         if len(args) > 0:
             revid = h.fix_revid(args[0])
@@ -65,9 +63,10 @@
             revid_list, revid = h.get_file_view(revid, file_id)
             rev = h.get_revision(revid)
             inv = h.get_inventory(revid)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
 
         # no navbar for revisions
         navigation = util.Container()

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2007-03-26 06:32:39 +0000
+++ loggerhead/controllers/revision_ui.py	2007-01-08 00:00:26 +0000
@@ -24,7 +24,7 @@
 import time
 
 import turbogears
-from cherrypy import InternalError, session
+from cherrypy import HTTPRedirect, session
 
 from loggerhead import util
 
@@ -35,14 +35,11 @@
         # BranchView object
         self._branch = branch
         self.log = branch.log
-    
-#    @util.lsprof
-    @util.strip_whitespace
+
     @turbogears.expose(html='loggerhead.templates.revision')
     def default(self, *args, **kw):
         z = time.time()
         h = self._branch.get_history()
-        util.set_context(kw)
         
         if len(args) > 0:
             revid = h.fix_revid(args[0])
@@ -52,14 +49,13 @@
         file_id = kw.get('file_id', None)
         start_revid = h.fix_revid(kw.get('start_revid', None))
         query = kw.get('q', None)
-        remember = kw.get('remember', None)
-        compare_revid = kw.get('compare_revid', None)
         
         try:
             revid, start_revid, revid_list = h.get_view(revid, start_revid, file_id, query)
-        except:
-            self.log.exception('Exception fetching changes')
-            raise InternalError('Could not fetch changes')
+        except Exception, x:
+            self.log.error('Exception fetching changes: %s' % (x,))
+            util.log_exception(self.log)
+            raise HTTPRedirect(self._branch.url('/changes'))
         
         navigation = util.Container(revid_list=revid_list, revid=revid, start_revid=start_revid, file_id=file_id,
                                     pagesize=1, scan_url='/revision', branch=self._branch, feed=True)
@@ -67,10 +63,7 @@
             navigation.query = query
         util.fill_in_navigation(h, navigation)
 
-        if compare_revid is not None:
-            change = h.get_diff(compare_revid, revid)
-        else:
-            change = h.get_changes([ revid ], get_diffs=True)[0]
+        change = h.get_changes([ revid ], get_diffs=True)[0]
         # add parent & merge-point branch-nick info, in case it's useful
         h.get_branch_nicks([ change ])
 
@@ -89,8 +82,6 @@
             'history': h,
             'navigation': navigation,
             'query': query,
-            'remember': remember,
-            'compare_revid': compare_revid,
             'side_by_side': side_by_side,
         }
         h.flush_cache()

=== modified file 'loggerhead/daemon.py'
--- loggerhead/daemon.py	2007-06-18 23:07:53 +0000
+++ loggerhead/daemon.py	2007-01-14 05:40:40 +0000
@@ -60,18 +60,3 @@
     f.write('%d\n' % (os.getpid(),))
     f.write('%s\n' % (home,))
     f.close()
-
-
-def is_running(pidfile):
-    try:
-        f = open(pidfile, 'r')
-    except IOError:
-        return False
-    pid = int(f.readline())
-    f.close()
-    try:
-        os.kill(pid, 0)
-    except OSError:
-        # no such process
-        return False
-    return True

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2007-05-29 11:19:07 +0000
+++ loggerhead/history.py	2007-01-14 01:22:51 +0000
@@ -141,24 +141,6 @@
         return False
 
 
-def clean_message(message):
-    # clean up a commit message and return it and a short (1-line) version
-    message = message.splitlines()
-    if len(message) == 1:
-        # robey-style 1-line long message
-        message = textwrap.wrap(message[0])
-    elif len(message) == 0:
-        # sometimes a commit may have NO message!
-        message = ['']
-        
-    # make short form of commit message
-    short_message = message[0]
-    if len(short_message) > 60:
-        short_message = short_message[:60] + '...'
-    
-    return message, short_message
-
-
 # from bzrlib
 class _RevListToTimestamps(object):
     """This takes a list of revisions, and allows you to bisect by date"""
@@ -424,8 +406,6 @@
         # if a "revid" is actually a dotted revno, convert it to a revid
         if revid is None:
             return revid
-        if revid == 'head:':
-            return self._last_revid
         if self.revno_re.match(revid):
             revid = self._revno_revid[revid]
         return revid
@@ -514,12 +494,6 @@
             path = '/' + path
         return path
     
-    @with_branch_lock
-    def get_file_id(self, revid, path):
-        if (len(path) > 0) and not path.startswith('/'):
-            path = '/' + path
-        return self._branch.repository.get_revision_inventory(revid).path2id(path)
-    
     def get_where_merged(self, revid):
         try:
             return self._where_merged[revid]
@@ -587,17 +561,10 @@
         p_changes = self.get_changes(list(fetch_set))
         p_change_dict = dict([(c.revid, c) for c in p_changes])
         for change in changes:
-            # arch-converted branches may not have merged branch info :(
             for p in change.parents:
-                if p.revid in p_change_dict:
-                    p.branch_nick = p_change_dict[p.revid].branch_nick
-                else:
-                    p.branch_nick = '(missing)'
+                p.branch_nick = p_change_dict[p.revid].branch_nick
             for p in change.merge_points:
-                if p.revid in p_change_dict:
-                    p.branch_nick = p_change_dict[p.revid].branch_nick
-                else:
-                    p.branch_nick = '(missing)'
+                p.branch_nick = p_change_dict[p.revid].branch_nick
     
     @with_branch_lock
     def get_changes(self, revid_list, get_diffs=False):
@@ -656,79 +623,60 @@
         finally:
             self._branch.repository.unlock()
     
-    def entry_from_revision(self, revision):
-        commit_time = datetime.datetime.fromtimestamp(revision.timestamp)
-        
-        parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in revision.parent_ids]
-
-        if len(parents) == 0:
-            left_parent = None
-        else:
-            left_parent = revision.parent_ids[0]
-        
-        message, short_message = clean_message(revision.message)
-
-        entry = {
-            'revid': revision.revision_id,
-            'revno': self.get_revno(revision.revision_id),
-            'date': commit_time,
-            'author': revision.committer,
-            'branch_nick': revision.properties.get('branch-nick', None),
-            'short_comment': short_message,
-            'comment': revision.message,
-            'comment_clean': [util.html_clean(s) for s in message],
-            'parents': parents,
-        }
-        return util.Container(entry)
-
     @with_branch_lock
     @with_bzrlib_read_lock
     def get_changes_uncached(self, revid_list, get_diffs=False):
-        done = False
-        while not done:
-            try:
-                rev_list = self._branch.repository.get_revisions(revid_list)
-                done = True
-            except (KeyError, bzrlib.errors.NoSuchRevision), e:
-                # this sometimes happens with arch-converted branches.
-                # i don't know why. :(
-                self.log.debug('No such revision (skipping): %s', e)
-                revid_list.remove(e.revision)
+        try:
+            rev_list = self._branch.repository.get_revisions(revid_list)
+        except (KeyError, bzrlib.errors.NoSuchRevision):
+            return None
         
         delta_list = self._get_deltas_for_revisions_with_trees(rev_list)
         combined_list = zip(rev_list, delta_list)
         
         entries = []
         for rev, (new_tree, old_tree, delta) in combined_list:
-            entry = self.entry_from_revision(rev)
-            entry.changes = self.parse_delta(delta, get_diffs, old_tree, new_tree)
-            entries.append(entry)
+            commit_time = datetime.datetime.fromtimestamp(rev.timestamp)
+            
+            parents = [util.Container(revid=r, revno=self.get_revno(r)) for r in rev.parent_ids]
+    
+            if len(parents) == 0:
+                left_parent = None
+            else:
+                left_parent = rev.parent_ids[0]
+            
+            message = rev.message.splitlines()
+            if len(message) == 1:
+                # robey-style 1-line long message
+                message = textwrap.wrap(message[0])
+            
+            # make short form of commit message
+            short_message = message[0]
+            if len(short_message) > 60:
+                short_message = short_message[:60] + '...'
+    
+            entry = {
+                'revid': rev.revision_id,
+                'revno': self.get_revno(rev.revision_id),
+                'date': commit_time,
+                'author': rev.committer,
+                'branch_nick': rev.properties.get('branch-nick', None),
+                'short_comment': short_message,
+                'comment': rev.message,
+                'comment_clean': [util.html_clean(s) for s in message],
+                'parents': parents,
+                'changes': self.parse_delta(delta, get_diffs, old_tree, new_tree),
+            }
+            entries.append(util.Container(entry))
         
         return entries
 
-    @with_bzrlib_read_lock
-    def _get_diff(self, revid1, revid2):
-        rev_tree1 = self._branch.repository.revision_tree(revid1)
-        rev_tree2 = self._branch.repository.revision_tree(revid2)
-        delta = rev_tree2.changes_from(rev_tree1)
-        return rev_tree1, rev_tree2, delta
-    
-    def get_diff(self, revid1, revid2):
-        rev_tree1, rev_tree2, delta = self._get_diff(revid1, revid2)
-        entry = self.get_changes([ revid2 ], False)[0]
-        entry.changes = self.parse_delta(delta, True, rev_tree1, rev_tree2)
-        return entry
-    
     @with_branch_lock
     def get_file(self, file_id, revid):
-        "returns (path, filename, data)"
-        inv = self.get_inventory(revid)
-        inv_entry = inv[file_id]
+        "returns (filename, data)"
+        inv_entry = self.get_inventory(revid)[file_id]
         rev_tree = self._branch.repository.revision_tree(inv_entry.revision)
-        path = inv.id2path(file_id)
-        if not path.startswith('/'):
-            path = '/' + path
-        return path, inv_entry.name, rev_tree.get_file_text(file_id)
+        return inv_entry.name, rev_tree.get_file_text(file_id)
     
     @with_branch_lock
     def parse_delta(self, delta, get_diffs=True, old_tree=None, new_tree=None):
@@ -809,13 +757,8 @@
             old_lines = old_tree.get_file_lines(fid)
             new_lines = new_tree.get_file_lines(fid)
             buffer = StringIO()
-            try:
-                bzrlib.diff.internal_diff(old_path, old_lines,
-                                          new_path, new_lines, buffer)
-            except bzrlib.errors.BinaryFile:
-                diff = ''
-            else:
-                diff = buffer.getvalue()
+            bzrlib.diff.internal_diff(old_path, old_lines, new_path, new_lines, buffer)
+            diff = buffer.getvalue()
             modified.append(util.Container(filename=rich_filename(new_path, kind), file_id=fid, chunks=process_diff(diff), raw_diff=diff))
 
         for path, fid, kind in delta.added:
@@ -854,6 +797,11 @@
         
         entries = inv.entries()
         
+        fetch_set = set()
+        for filepath, entry in entries:
+            fetch_set.add(entry.revision)
+        change_dict = dict([(c.revid, c) for c in self.get_changes(list(fetch_set))])
+        
         file_list = []
         for filepath, entry in entries:
             if posixpath.dirname(filepath) != path:
@@ -863,12 +811,10 @@
             pathname = filename
             if entry.kind == 'directory':
                 pathname += '/'
-
+            
+            # last change:
             revid = entry.revision
-            revision = self._branch.repository.get_revision(revid)
-
-            change = util.Container(date=datetime.datetime.fromtimestamp(revision.timestamp),
-                                    revno=self.get_revno(revid))
+            change = change_dict[revid]
             
             file = util.Container(filename=filename, rich_filename=rich_filename, executable=entry.executable, kind=entry.kind,
                                   pathname=pathname, file_id=entry.file_id, size=entry.text_size, revid=revid, change=change)
@@ -889,7 +835,7 @@
         return file_list
 
 
-    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b\x0e-\x1f]')
+    _BADCHARS_RE = re.compile(ur'[\x00-\x08\x0b-\x0c\x0e-\x1f]')
 
     @with_branch_lock
     def annotate_file(self, file_id, revid):
@@ -938,14 +884,13 @@
 
     @with_branch_lock
     @with_bzrlib_read_lock
-    def get_bundle(self, revid, compare_revid=None):
-        if compare_revid is None:
-            parents = self._revision_graph[revid]
-            if len(parents) > 0:
-                compare_revid = parents[0]
-            else:
-                compare_revid = None
+    def get_bundle(self, revid):
+        parents = self._revision_graph[revid]
+        if len(parents) > 0:
+            parent_revid = parents[0]
+        else:
+            parent_revid = None
         s = StringIO()
-        bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, compare_revid, s)
+        bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, parent_revid, s)
         return s.getvalue()
 

=== modified file 'loggerhead/release.py'
--- loggerhead/release.py	2007-01-24 19:29:58 +0000
+++ loggerhead/release.py	2006-12-23 19:29:05 +0000
@@ -1,6 +1,6 @@
 # Release information about loggerhead
 
-version = "1.1.1-0.13"
+version = "1.0-0.13"
 
 description = "Loggerhead is a web viewer for projects in bazaar."
 
@@ -9,4 +9,4 @@
 
 license = "GPL"
 url = "http://www.lag.net/loggerhead/"
-download_url = "http://www.lag.net/loggerhead/download/loggerhead-1.1.1-0.13.tar.gz"
+download_url = "http://www.lag.net/loggerhead/download/..."

=== modified file 'loggerhead/static/css/style.css'
--- loggerhead/static/css/style.css	2007-01-24 19:17:40 +0000
+++ loggerhead/static/css/style.css	2007-01-14 05:42:46 +0000
@@ -62,14 +62,8 @@
 .navbar {
 }
 
-.bar table {
+.navbar table, .bar table {
     width: 100%;
-    border-collapse: collapse;
-}
-
-/* safari gives forms a big default margin, to vex me */
-.bar form {
-    margin: 0px;
 }
 
 .bar {
@@ -449,17 +443,13 @@
 }
 .diff .lineno-skip {
     width: 4em;
-    background-color: #dee7ec;
+    background-color: #dee7ec; 
 }
 .diff .info {
     color: blue;
     background-color: #dee7ec;
     margin-top: 15px;
 }
-/*
-.diff-context-skip {
-    background-color: #dee7ec;
-}*/
 
 
 /* ----- file inventory ----- */

=== modified file 'loggerhead/templates/annotate.kid'
--- loggerhead/templates/annotate.kid	2007-05-21 08:06:44 +0000
+++ loggerhead/templates/annotate.kid	2006-12-20 09:29:42 +0000
@@ -12,9 +12,9 @@
 
 <h1> <span class="branch-name">${branch.friendly_name}</span> : <span class="annotate-path">${path}</span> (revision ${change.revno})
 	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context(clear=1))}"> browse files </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}"> view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid, file_id=file_id))}"> view changes to this file </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ])}"> browse files </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', start_revid=revid)}"> view revision </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', start_revid=revid, file_id=file_id)}"> view changes to this file </a> </div>
 	    <div> <b>&#8594;</b> <a href="${branch.url([ '/download', revid, file_id, filename ])}"> view/download file </a> </div>
 	</div>
 </h1>
@@ -28,9 +28,9 @@
         </tr>
 
         <tr py:for="line in contents" class="parity${line.parity}">
-            <td class="lineno ${line.status}"><a name="L${line.lineno}"> ${line.lineno} </a></td>
+            <td class="lineno ${line.status}"> ${line.lineno} </td>
             <td class="revno ${line.status}">
-                <a py:if="line.status=='changed'" href="${branch.url('/revision', **util.get_context(clear=1, start_revid=line.change.revid, file_id=file_id))}"
+                <a py:if="line.status=='changed'" href="${branch.url('/revision', start_revid=line.change.revid, file_id=file_id)}"
                     title="${line.change.revno} by ${util.hide_email(line.change.author)}, on ${line.change.date.strftime('%d %b %Y %H:%M')} (${util.ago(line.change.date)})">${util.trunc(line.change.revno)}</a>
             </td>
             <td class="text ${line.status}"> ${XML(line.text)} </td>

=== modified file 'loggerhead/templates/atom.kid'
--- loggerhead/templates/atom.kid	2007-03-29 06:55:55 +0000
+++ loggerhead/templates/atom.kid	2006-12-20 21:24:32 +0000
@@ -2,18 +2,17 @@
 <feed xmlns="http://www.w3.org/2005/Atom" xmlns:py="http://purl.org/kid/ns#">
     <title> bazaar changes for ${branch.friendly_name} </title>
     <updated>${updated}</updated>
-    <id>${branch.url(['atom'])}</id>
-    <link rel="self" href="${branch.url([''])}" />
+    <id>${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}</id>
+    <link rel="self" href="${tg.url([ external_url, branch.group_name, branch.name, 'atom' ])}" />
 
 	<entry py:for="entry in changes">
 	    <title> ${entry.revno}: ${entry.short_comment} </title>
 	    <updated>${entry.date.isoformat() + 'Z'}</updated>
-	    <id>${branch.url(['revision', entry.revid ])}</id>
+	    <id>${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}</id>
 	    <author> <name> ${util.hide_email(entry.author)} </name> </author>
 	    <content type="text">
             ${entry.comment}
 	    </content>
-	    <link rel="alternate"
-                  href="${branch.url(['revision', entry.revid ])}" />
+	    <link rel="alternate" href="${tg.url([ external_url, branch.group_name, branch.name, 'revision', entry.revid ])}" />
 	</entry>
 </feed>

=== modified file 'loggerhead/templates/browse.kid'
--- loggerhead/templates/browse.kid	2007-01-21 00:05:52 +0000
+++ loggerhead/templates/browse.kid	2007-01-05 19:09:42 +0000
@@ -34,7 +34,7 @@
             <tr>
             <td class="name"> <a href="${tg.url([ '/' + project.name, view.name ])}">${view.friendly_name}</a> </td>
             <td class="description"> ${view.description} </td>
-            <td class="last-update"> ${util.ago(view.last_updated())} </td>
+            <td class="last-update"> <!--${view.last_updated().strftime('%d %b %Y')} &nbsp;--> ${util.ago(view.last_updated())} </td>
             <td class="feed">
                 <a href="${tg.url([ '/' + project.name, view.name, 'atom' ])}" title="atom feed">
                     <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" alt="atom feed" />

=== modified file 'loggerhead/templates/changelog.kid'
--- loggerhead/templates/changelog.kid	2007-01-21 00:05:52 +0000
+++ loggerhead/templates/changelog.kid	2007-01-14 05:43:10 +0000
@@ -7,11 +7,11 @@
     <link rel="alternate" type="application/atom+xml" href="${branch.url('/atom')}" title="RSS feed for ${branch.friendly_name}" />
     
     <span py:def="loglink(revid, text)">
-        <a title="Show history" href="${branch.url('/changes', **util.get_context(start_revid=revid))}" class="revlink"> ${text} </a>
+        <a title="Show history" href="${branch.url('/changes', start_revid=revid)}" class="revlink"> ${text} </a>
     </span>
 
     <span py:def="file_link(filename, file_id, revid)">
-        <a href="${branch.url([ '/annotate', revid ], **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
+        <a href="${branch.url([ '/annotate', revid ], file_id=file_id)}" title="Annotate ${filename}">${filename}</a>
     </span>
     
     ${use_collapse_buttons()}
@@ -39,9 +39,9 @@
         <div class="revision-header">
             <table>
                 <tr>
-                    <td class="revision-number"> ${revision_link(entry.revid, util.trunc(entry.revno))} </td>
+                    <td class="revision-number"> ${revlink_q(entry.revid, start_revid, file_id, query, util.trunc(entry.revno))} </td>
                     <td class="expand-button"> ${collapse_button('cl', entry.revno)} </td>
-					<td class="summary"> ${revision_link(entry.revid, entry.short_comment)} </td>
+					<td class="summary"> ${revlink_q(entry.revid, start_revid, file_id, query, entry.short_comment)} </td>
 					<td class="inventory-link"> <a href="${branch.url([ '/files', entry.revid ])}">&#8594; files</a> </td>
 				</tr>
 			</table>
@@ -97,7 +97,7 @@
 			            <th class="files"> files modified: </th>
 			            <td class="files"> <span py:for="item in entry.changes.modified">
 			                <span class="filename">${file_link(item.filename, item.file_id, entry.revid)}</span> &nbsp;
-			                <a href="${branch.url([ '/revision', entry.revid ], **util.get_context()) + '#' + item.filename}" class="jump">&#8594; diff</a>
+			                <a href="${branch.url([ '/revision', entry.revid ], start_revid=start_revid, file_id=file_id, query=query) + '#' + item.filename}" class="jump">&#8594; diff</a>
 			                <br />
 			            </span> </td>
 			        </tr>

=== modified file 'loggerhead/templates/inventory.kid'
--- loggerhead/templates/inventory.kid	2007-01-24 19:26:50 +0000
+++ loggerhead/templates/inventory.kid	2006-12-29 02:24:03 +0000
@@ -12,10 +12,8 @@
 
 <h1> <span class="branch-name">${branch.friendly_name}</span> : files for revision ${change.revno}
 	<div class="links">
-	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', **util.get_context(clear=1, start_revid=revid))}">
-	        view revision </a> </div>
-	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(clear=1, start_revid=revid))}">
-	        view branch changes </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/revision', start_revid=revid)}"> view revision </a> </div>
+	    <div> <b>&#8594;</b> <a href="${branch.url('/changes', start_revid=revid)}"> view branch changes </a> </div>
 	</div>
 </h1>
 
@@ -35,7 +33,7 @@
             <th class="children"> merged in: </th>
             <td class="children">
                 <span py:for="child in change.merge_points">
-                    ${revision_link(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', clear=1, start_revid=child.revid)} <br />
+                    ${revlink(child.revid, child.revid, None, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br />
                 </span>
             </td>
         </tr>
@@ -43,7 +41,7 @@
         	<th class="parents"> merged from: </th>
         	<td class="parents">
         	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-        	        ${revision_link(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', clear=1, start_revid=parent.revid)} <br />
+        	        ${revlink(parent.revid, parent.revid, None, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
         	    </span></span>
         	</td>
         </tr>
@@ -62,40 +60,35 @@
 <table class="inventory" width="100%">
     <tr class="header">
         <th class="permissions"> Permissions </th>
-        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='filename'))}">Filename</a> </th>
-        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='size'))}">Size</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], file_id=file_id, sort='filename')}">Filename</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], file_id=file_id, sort='size')}">Size</a> </th>
         <th> Last change </th>
-        <th> <a href="${branch.url([ '/files', revid ], **util.get_context(sort='date'))}">When</a> </th>
+        <th> <a href="${branch.url([ '/files', revid ], file_id=file_id, sort='date')}">When</a> </th>
         <th> History </th>
         <th> Download </th>
     </tr>
     
     <tr class="parity1" py:if="updir">
         <td class="permissions">drwxr-xr-x</td>
-        <td class="filename directory"><a href="${branch.url([ '/files', revid ],
-            **util.get_context(file_id=updir_file_id))}"> (up) </a></td>
+        <td class="filename directory"><a href="${branch.url([ '/files', revid ], file_id=updir_file_id)}"> (up) </a></td>
         <td> </td> <td> </td> <td> </td> <td> </td>
     </tr>
 
     <tr py:for="file in filelist" class="parity${file.parity}">
         <td class="permissions"> ${util.fake_permissions(file.kind, file.executable)} </td>
         <td class="filename ${file.kind}">
-            <a py:if="file.kind=='directory'" href="${branch.url([ '/files', revid ],
-                **util.get_context(file_id=file.file_id))}">${file.filename}/</a>
+            <a py:if="file.kind=='directory'" href="${branch.url([ '/files', revid ], file_id=file.file_id)}">${file.filename}/</a>
             <span py:if="file.kind=='symlink'">${file.filename}@</span>
-            <a py:if="file.kind=='file'" href="${branch.url([ '/annotate', revid ],
-                **util.get_context(file_id=file.file_id))}" title="Annotate ${file.filename}">${file.filename}</a>
+            <a py:if="file.kind=='file'" href="${branch.url([ '/annotate', revid ], file_id=file.file_id)}" title="Annotate ${file.filename}">${file.filename}</a>
         </td>
         <td class="size"> <span py:if="file.kind=='file'"> ${util.human_size(file.size)} </span></td>
-        <td class="revision"> ${revision_link(file.revid, util.trunc(file.change.revno, 15), **util.get_context(start_revid=file.revid, file_id=file.file_id))} </td>
+        <td class="revision"> ${revlink(file.revid, file.revid, file.file_id, util.trunc(file.change.revno, 15))} </td>
         <td class="date"> ${file.change.date.strftime('%d %b %Y %H:%M')} </td>
         <td class="changes-link"> 
-            <a href="${branch.url('/changes', **util.get_context(start_revid=file.revid, file_id=file.file_id))}"
-               title="Changes from ${file.change.revno} affecting ${file.filename}"> &#8594; changes </a>
+            <a href="${branch.url('/changes', start_revid=file.revid, file_id=file.file_id)}" title="Changes from ${file.change.revno} affecting ${file.filename}"> &#8594; changes </a>
         </td>
         <td class="download-link">
-            <a href="${branch.url([ '/download', file.revid, file.file_id, file.filename ])}"
-               title="Download ${file.filename} at revision ${file.change.revno}"> &#8594; download </a></td>
+            <a href="${branch.url([ '/download', file.revid, file.file_id, file.filename ])}" title="Download ${file.filename} at revision ${file.change.revno}"> &#8594; download </a></td>
     </tr>
 </table>
 

=== added file 'loggerhead/templates/login.kid'
--- loggerhead/templates/login.kid	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/login.kid	2006-12-11 06:44:19 +0000
@@ -0,0 +1,113 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
+    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml"
+    xmlns:py="http://purl.org/kid/ns#"
+    py:extends="'master.kid'">
+
+<head>
+    <meta content="text/html; charset=UTF-8"
+        http-equiv="content-type" py:replace="''"/>
+    <title>Login</title>
+    <style type="text/css">
+        #loginBox
+        {
+            width: 30%;
+            margin: auto;
+            margin-top: 10%;
+            padding-left: 10%;
+            padding-right: 10%;
+            padding-top: 5%;
+            padding-bottom: 5%;
+            font-family: verdana;
+            font-size: 10px;
+            background-color: #eee;
+            border: 2px solid #ccc;
+        }
+
+        #loginBox h1
+        {
+            font-size: 42px;
+            font-family: "Trebuchet MS";
+            margin: 0;
+            color: #ddd;
+        }
+
+        #loginBox p
+        {
+            position: relative;
+            top: -1.5em;
+            padding-left: 4em;
+            font-size: 12px;
+            margin: 0;
+            color: #666;
+        }
+
+        #loginBox table
+        {
+            table-layout: fixed;
+            border-spacing: 0;
+            width: 100%;
+        }
+
+        #loginBox td.label
+        {
+            width: 33%;
+            text-align: right;
+        }
+
+        #loginBox td.field
+        {
+            width: 66%;
+        }
+
+        #loginBox td.field input
+        {
+            width: 100%;
+        }
+
+        #loginBox td.buttons
+        {
+            text-align: right;
+        }
+
+    </style>
+</head>
+
+<body>
+    <div id="loginBox">
+        <h1>Login</h1>
+        <p>${message}</p>
+        <form action="${previous_url}" method="POST">
+            <table>
+                <tr>
+                    <td class="label">
+                        <label for="user_name">User Name:</label>
+                    </td>
+                    <td class="field">
+                        <input type="text" id="user_name" name="user_name"/>
+                    </td>
+                </tr>
+                <tr>
+                    <td class="label">
+                        <label for="password">Password:</label>
+                    </td>
+                    <td class="field">
+                        <input type="password" id="password" name="password"/>
+                    </td>
+                </tr>
+                <tr>
+                    <td colspan="2" class="buttons">
+                        <input type="submit" name="login" value="Login"/>
+                    </td>
+                </tr>
+            </table>
+
+            <input py:if="forward_url" type="hidden" name="forward_url"
+                value="${forward_url}"/>
+                
+            <input py:for="name,value in original_parameters.items()"
+                type="hidden" name="${name}" value="${value}"/>
+        </form>
+    </div>
+</body>
+</html>

=== modified file 'loggerhead/templates/master.kid'
--- loggerhead/templates/master.kid	2007-01-24 19:17:40 +0000
+++ loggerhead/templates/master.kid	2007-01-08 07:06:06 +0000
@@ -11,96 +11,79 @@
     </style>
 
 <!-- !define common navbar -->
-<span py:def="navbar()" py:strip="True">
+<span py:def="navbar()">
     <!-- !requires: ${navigation: start_revid, revid, revid_list, pagesize, buttons, scan_url}, ${branch}, ${history} -->
-    <div class="bar" py:if="navigation is not None">
-        <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
-        <form action="${branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None),
-              file_id=getattr(navigation, 'file_id', None))}"><table><tr>
-            <td><span class="buttons">
-                <!-- ! navbar buttons never change, from now on.  i decree it! -->
-                <a href="${branch.url('/changes', **util.get_context(clear=1))}"> changes </a>
-                <a href="${branch.url('/files', **util.get_context(clear=1))}"> files </a>
-                <span class="search"> search: <input type="text" name="q" /> </span>
-            </span></td>
-            <td align="right" py:if="hasattr(navigation, 'revid_list')">
-                <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
-                    <a href="${branch.url('/atom')}">
-                    <img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
-                </span>
-                <span class="navbuttons">
-                	<span py:if="navigation.prev_page_revid">
-                	<a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>
-                    </span>
-                	<span py:if="not navigation.prev_page_revid"> &#171; </span>
-                    revision ${history.get_revno(revid)}
-                    (<span py:if="navigation.pagesize > 1">page </span>
-                    ${navigation.page_position} / ${navigation.page_count})
-                	<span py:if="navigation.next_page_revid">
-                    <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>
-                    </span>
-                	<span py:if="not navigation.next_page_revid"> &#187; </span>
-                </span>
-            </td>
-        </tr></table></form>
+    <div class="navbar" py:if="navigation is not None">
+        <div class="bar">
+            <!-- form must go OUTSIDE the table, or safari will add extra padding :( -->
+            <form action="${branch.url('/changes', start_revid=getattr(navigation, 'start_revid', None), file_id=getattr(navigation, 'file_id', None))}">
+            <table>
+                <tr><td>
+                    <span class="buttons">
+                        <!-- ! navbar buttons never change, from now on.  i decree it! -->
+                        <a href="${branch.url('/changes')}"> changes </a>
+                        <a href="${branch.url('/files')}"> files </a>
+                        <span class="search"> search: <input type="text" name="q" /> </span>
+                    </span>
+                </td><td align="right" py:if="hasattr(navigation, 'revid_list')">
+                    <span py:if="hasattr(navigation, 'feed')" class="rbuttons feed">
+                        <a href="${branch.url('/atom')}"><img src="${tg.url('/static/images/feed-icon-16x16.gif')}" /></a>
+                    </span>
+                    <span class="navbuttons">
+                    	<span py:if="navigation.prev_page_revid"> <a href="${navigation.prev_page_url}" title="Previous page"> &#171; </a>	</span>
+                    	<span py:if="not navigation.prev_page_revid"> &#171; </span>
+                        	revision ${history.get_revno(revid)} (<span py:if="navigation.pagesize > 1">page </span>${navigation.page_position} / ${navigation.page_count})
+                    	<span py:if="navigation.next_page_revid"> <a href="${navigation.next_page_url}" title="Next page"> &#187; </a>	</span>
+                    	<span py:if="not navigation.next_page_revid"> &#187; </span>
+                    </span>
+                </td></tr>
+            </table>
+            </form>
+        </div>
     </div>
 </span>
 
-<span py:def="revision_link(revid, text, **overrides)" py:strip="True">
-    <a title="Show revision ${history.get_revno(revid)}"
-       href="${branch.url([ '/revision', revid ], **util.get_context(**overrides))}"> ${text} </a>
-</span>
-
+<span py:def="revlink(revid, start_revid, file_id, text)">
+    <a title="Show revision ${history.get_revno(revid)}" href="${branch.url([ '/revision', revid ], start_revid=start_revid, file_id=file_id)}" class="revlink"> ${text} </a>
+</span>
+<span py:def="revlink_q(revid, start_revid, file_id, query, text)">
+    <a title="Show revision ${history.get_revno(revid)}" href="${branch.url([ '/revision', revid ], start_revid=start_revid, file_id=file_id, q=query)}" class="revlink"> ${text} </a>
+</span>
 
 <!-- ! expand button functions: -->
 
-	<span py:strip="True" py:def="use_collapse_buttons()">
+	<span py:def="use_collapse_buttons()">
 		<!-- this is totally matty's fault.  i don't like javacsript. ;) -->
 		<script type="text/javascript" src="${tg.url('/static/javascript/collapse.js')}"></script>
 	</span>
 	
 	<span py:strip="True" py:def="collapse_all_button(group, normal='block')">
-	    <a class="hide-all collapse-${group}-hideall"
-	       href="javascript:collapseAllDisplay('${group}','none')">
-	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
-	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />collapse all</a>
-	    <a class="hide-all collapse-${group}-showall"
-	       href="javascript:collapseAllDisplay('${group}','${normal}')">
-	        <img src="${tg.url('/static/images/nav-small-right.gif')}"
-	             width="10" height="10" alt="expand"
-	             class="collapse-triangle" />expand all</a>
+	    <a class="hide-all collapse-${group}-hideall" href="javascript:collapseAllDisplay('${group}','none')">
+	        <img src="${tg.url('/static/images/nav-small-down.gif')}" width="10" height="10" alt="collapse" class="collapse-triangle" />collapse all</a>
+	    <a class="hide-all collapse-${group}-showall" href="javascript:collapseAllDisplay('${group}','${normal}')">
+	        <img src="${tg.url('/static/images/nav-small-right.gif')}" width="10" height="10" alt="expand" class="collapse-triangle" />expand all</a>
 	</span>
 	
 	<span py:strip="True" py:def="collapse_button(group, name, normal='block')">
-	    <a href="javascript:collapseDisplay('${group}','${name}','none')"
-	       class="hide-button collapse-${group}-${name}-hide" title="collapse">
-	        <img src="${tg.url('/static/images/nav-small-down.gif')}"
-	             width="10" height="10" alt="collapse"
-	             class="collapse-triangle" />
+	    <a href="javascript:collapseDisplay('${group}','${name}','none')" class="hide-button collapse-${group}-${name}-hide" title="collapse">
+	        <img src="${tg.url('/static/images/nav-small-down.gif')}" width="10" height="10" alt="collapse" class="collapse-triangle" />
 	    </a>
-	    <a href="javascript:collapseDisplay('${group}','${name}','${normal}')"
-	       class="show-button collapse-${group}-${name}-show" title="expand">
-	    	<img src="${tg.url('/static/images/nav-small-right.gif')}"
-	    	     witdh="10" height="10" alt="expand"
-	    	     class="collapse-triangle" />
+	    <a href="javascript:collapseDisplay('${group}','${name}','${normal}')" class="show-button collapse-${group}-${name}-show" title="expand">
+	    	<img src="${tg.url('/static/images/nav-small-right.gif')}" witdh="10" height="10" alt="expand" class="collapse-triangle" />
 	    </a>
 	</span>
 
 </head>
 
-<body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'"
-      py:attrs="item.items()">
+<body py:match="item.tag=='{http://www.w3.org/1999/xhtml}body'" py:attrs="item.items()">
 
     <div py:replace="[item.text]+item[:]"/>
 
 	<!-- End of main_content -->
 	
 	<div class="footer">
-	    <span class="banner"><a href="http://www.bazaar-vcs.org/">
-	    <img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
-	    <span class="banner"><a href="http://www.lag.net/loggerhead/">
-	    <img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
+	    <span class="banner"><a href="http://www.bazaar-vcs.org/"><img src="${tg.url('/static/images/bazaar-banner.png')}" /></a></span>
+	    <span class="banner"><a href="http://www.lag.net/loggerhead/"><img src="${tg.url('/static/images/loggerhead-banner.png')}" /></a></span>
 	</div>
 </body>
 

=== modified file 'loggerhead/templates/revision.kid'
--- loggerhead/templates/revision.kid	2007-01-24 19:26:50 +0000
+++ loggerhead/templates/revision.kid	2007-01-14 02:00:56 +0000
@@ -6,27 +6,15 @@
     <title> ${branch.friendly_name} : revision ${change.revno} </title>
     
     <span py:strip="True" py:def="file_link(filename, file_id)">
-        <a href="${branch.url([ '/annotate', revid ],
-            **util.get_context(file_id=file_id))}" title="Annotate ${filename}">${filename}</a>
+        <a href="${branch.url([ '/annotate', revid ], file_id=file_id)}" title="Annotate ${filename}">${filename}</a>
     </span>
     
     <span py:replace="use_collapse_buttons()"></span>
     
     <script type="text/javascript"> <!--
-    function show_sbs() {
-        collapseDisplay('style', 'sbs', 'table');
-        collapseDisplay('style', 'unified', 'none');
-        document.cookie='diff=sbs';
-    }
-    function show_unified() {
-        collapseDisplay('style', 'unified', 'table');
-        collapseDisplay('style', 'sbs', 'none');
-        document.cookie='diff=unified'; 
-    }
-    function load() {
-        sortCollapseElements();
-        if (document.cookie.indexOf('diff=unified') >= 0) { show_unified(); }
-    }
+    function show_sbs() { collapseDisplay('style', 'sbs', 'table'); collapseDisplay('style', 'unified', 'none'); document.cookie='diff=sbs'; }
+    function show_unified() { collapseDisplay('style', 'unified', 'table'); collapseDisplay('style', 'sbs', 'none'); document.cookie='diff=unified'; }
+    function load() { sortCollapseElements(); if (document.cookie.indexOf('diff=unified') >= 0) { show_unified(); } }
     // --> </script>
 </head>
 
@@ -35,36 +23,10 @@
 ${navbar()}
 
 <h1> <span class="branch-name">${branch.friendly_name}</span> : revision ${change.revno}
-    <span py:if="compare_revid is not None"> (compared to revision ${history.get_revno(compare_revid)}) </span>
-    
     <div class="links">
-        <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ], **util.get_context())}">
-            browse files</a> </div>
-        <div> <b>&#8594;</b> <a href="${branch.url('/changes', **util.get_context(start_revid=revid))}">
-            view branch changes</a> </div>
-        <span py:if="compare_revid is None" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, 'bundle.txt' ])}">
-                view/download patch</a> </div>
-        </span>
-        <span py:if="compare_revid is not None" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, compare_revid, 'bundle.txt' ])}">
-                view/download patch</a> </div>
-        </span>
-        <span py:if="(remember is not None) and (compare_revid is None)" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
-                **util.get_context(compare_revid=remember))}">
-                compare with revision ${history.get_revno(remember)} </a></div>
-        </span>
-        <span py:if="remember != revid" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
-                **util.get_context(remember=revid, compare_revid=None))}">
-                compare with another revision </a></div>
-        </span>
-        <span py:if="compare_revid is not None" py:strip="True">
-            <div> <b>&#8594;</b> <a href="${branch.url([ '/revision', revid ],
-                **util.get_context(remember=None, compare_revid=None))}">
-                stop comparing to revision ${history.get_revno(compare_revid)} </a></div>
-        </span>
+        <div> <b>&#8594;</b> <a href="${branch.url([ '/files', revid ])}">browse files</a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url('/changes', start_revid=revid)}">view branch changes</a> </div>
+        <div> <b>&#8594;</b> <a href="${branch.url([ '/bundle', revid, 'bundle.txt' ])}">view/download patch</a> </div>
     </div>
 </h1>
  
@@ -83,7 +45,7 @@
             <th class="children"> merged in: </th>
             <td class="children">
                 <span py:for="child in change.merge_points">
-                    ${revision_link(child.revid, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')', clear=1, start_revid=child.revid)} <br /> 
+                    ${revlink(child.revid, child.revid, None, '(' + child.revno + util.if_present(' %s', child.branch_nick) + ')')} <br /> 
                 </span>
             </td>
         </tr>
@@ -91,7 +53,7 @@
         	<th class="parents"> merged from: </th>
         	<td class="parents">
         	    <span py:for="parent in change.parents"><span py:if="parent.revid != change.parents[0].revid">
-        	        ${revision_link(parent.revid, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')', clear=1, start_revid=parent.revid)} <br />
+        	        ${revlink(parent.revid, parent.revid, None, '(' + parent.revno + util.if_present(' %s', parent.branch_nick) + ')')} <br />
         	    </span></span>
         	</td>
         </tr>
@@ -155,7 +117,7 @@
         <span py:strip="True" py:for="item in change.changes.modified">
             <tr><th class="filename" colspan="4">
                 ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
-                <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}" name="${item.filename}">${item.filename}</a>
+                <a href="${branch.url([ '/annotate', change.revid ], file_id=item.file_id)}" name="${item.filename}">${item.filename}</a>
             </th></tr>
 
             <span py:strip="True" py:for="chunk in item.sbs_chunks">
@@ -163,22 +125,12 @@
                     <th class="lineno">old</th> <th></th> <th class="lineno">new</th> <th></th>
                 </tr>
                 <tr py:for="line in chunk.diff" class="diff-chunk collapse-file-${util.uniq(uniqs, item.file_id)}-content">
-                    <span py:if="line.old_lineno" py:strip="True">
-                        <td class="lineno">${line.old_lineno}</td>
-                        <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
-                    </span>
-                    <span py:if="not line.old_lineno" py:strip="True">
-                        <td class="lineno-skip">${line.old_lineno}</td>
-                        <td class="diff-${line.old_type}-skip">${XML(line.old_line)}</td>
-                    </span>
-                    <span py:if="line.new_lineno" py:strip="True">
-                        <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
-                        <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
-                    </span>
-                    <span py:if="not line.new_lineno" py:strip="True">
-                        <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
-                        <td class="diff-${line.new_type}-skip">${XML(line.new_line)}</td>
-                    </span>
+                    <td py:if="line.old_lineno" class="lineno">${line.old_lineno}</td>
+                    <td py:if="not line.old_lineno" class="lineno-skip">${line.old_lineno}</td>
+                    <td class="diff-${line.old_type}">${XML(line.old_line)}</td>
+                    <td py:if="line.new_lineno" class="lineno">${line.new_lineno}</td>
+                    <td py:if="not line.new_lineno" class="lineno-skip">${line.new_lineno}</td>
+                    <td class="diff-${line.new_type}">${XML(line.new_line)}</td>
                 </tr>
                 <tr class="diff-chunk-spacing collapse-file-${util.uniq(uniqs, item.file_id)}-content"> <td colspan="4"> &nbsp; </td> </tr>
             </span>
@@ -191,7 +143,7 @@
 	    <span py:strip="True" py:for="item in change.changes.modified">
 	        <tr><th class="filename" colspan="4">
 	            ${collapse_button('file', util.uniq(uniqs, item.file_id), 'table-row')}
-	            <a href="${branch.url([ '/annotate', change.revid ], **util.get_context(file_id=item.file_id))}" name="${item.filename}">${item.filename}</a>
+	            <a href="${branch.url([ '/annotate', change.revid ], file_id=item.file_id)}" name="${item.filename}">${item.filename}</a>
 	        </th></tr>
 	
 	        <span py:strip="True" py:for="chunk in item.chunks">

=== added file 'loggerhead/templates/welcome.kid'
--- loggerhead/templates/welcome.kid	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/welcome.kid	2006-12-11 06:44:19 +0000
@@ -0,0 +1,50 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<html xmlns="http://www.w3.org/1999/xhtml" xmlns:py="http://purl.org/kid/ns#"
+    py:extends="'master.kid'">
+<head>
+<meta content="text/html; charset=utf-8" http-equiv="Content-Type" py:replace="''"/>
+<title>Welcome to TurboGears</title>
+</head>
+<body>
+<div id="header">&nbsp;</div>
+<div id="main_content">
+  <div id="status_block">Your TurboGears application is now running.</div>
+  <!--h1>Take steps to dive right in:</h1-->
+  <div id="sidebar">
+    <h2>Learn more</h2>
+    Learn more about TurboGears and take part in its
+    development
+    <ul class="links">
+      <li><a href="http://www.turbogears.org">Official website</a></li>
+      <li><a href="http://docs.turbogears.org">Documentation</a></li>
+      <li><a href="http://trac.turbogears.org/turbogears/">Trac
+        (bugs/suggestions)</a></li>
+      <li><a href="http://groups.google.com/group/turbogears"> Mailing list</a> </li>
+    </ul>
+  </div>
+  <div id="getting_started">
+    <ol id="getting_started_steps">
+      <li class="getting_started">
+        <h3>Model</h3>
+        <p> <a href="http://docs.turbogears.org/1.0/GettingStarted/DefineDatabase">Design models</a> in the <span class="code">model.py</span>.<br/>
+          Edit <span class="code">dev.cfg</span> to <a href="http://docs.turbogears.org/1.0/GettingStarted/UseDatabase">use a different backend</a>, or start with a pre-configured SQLite database. <br/>
+          Use script <span class="code">tg-admin sql create</span> to create the database tables.</p>
+      </li>
+      <li class="getting_started">
+        <h3>View</h3>
+        <p> Edit <a href="http://docs.turbogears.org/1.0/GettingStarted/Kid">html-like templates</a> in the <span class="code">/templates</span> folder;<br/>
+        Put all <a href="http://docs.turbogears.org/1.0/StaticFiles">static contents</a> in the <span class="code">/static</span> folder. </p>
+      </li>
+      <li class="getting_started">
+        <h3>Controller</h3>
+        <p> Edit <span class="code"> controllers.py</span> and <a href="http://docs.turbogears.org/1.0/GettingStarted/CherryPy">build your
+          website structure</a> with the simplicity of Python objects. <br/>
+          TurboGears will automatically reload itself when you modify your project. </p>
+      </li>
+    </ol>
+    <div class="notice"> If you create something cool, please <a href="http://groups.google.com/group/turbogears">let people know</a>, and consider contributing something back to the <a href="http://groups.google.com/group/turbogears">community</a>.</div>
+  </div>
+  <!-- End of getting_started -->
+</div>
+</body>
+</html>

=== added file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_controllers.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,16 @@
+from turbogears import testutil
+from loggerhead.controllers import Root
+import cherrypy
+
+cherrypy.root = Root()
+
+def test_method():
+    "the index method should return a string called now"
+    import types
+    result = testutil.call(cherrypy.root.index)
+    assert type(result["now"]) == types.StringType
+
+def test_indextitle():
+    "The mainpage should have the right title"
+    testutil.createRequest("/")
+    assert "<TITLE>Welcome to TurboGears</TITLE>" in cherrypy.response.body[0]

=== added file 'loggerhead/tests/test_model.py'
--- loggerhead/tests/test_model.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_model.py	2006-12-11 06:44:19 +0000
@@ -0,0 +1,22 @@
+# If your project uses a database, you can set up database tests
+# similar to what you see below. Be sure to set the db_uri to
+# an appropriate uri for your testing database. sqlite is a good
+# choice for testing, because you can use an in-memory database
+# which is very fast.
+
+from turbogears import testutil, database
+# from loggerhead.model import YourDataClass, User
+
+# database.set_db_uri("sqlite:///:memory:")
+
+# class TestUser(testutil.DBTest):
+#     def get_model(self):
+#         return User
+#     def test_creation(self):
+#         "Object creation should set the name"
+#         obj = User(user_name = "creosote",
+#                       email_address = "spam@python.not",
+#                       display_name = "Mr Creosote",
+#                       password = "Wafer-thin Mint")
+#         assert obj.display_name == "Mr Creosote"
+

=== removed file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2007-05-29 12:26:42 +0000
+++ loggerhead/tests/test_simple.py	1970-01-01 00:00:00 +0000
@@ -1,82 +0,0 @@
-from configobj import ConfigObj
-import unittest
-import os
-import tempfile
-import shutil
-
-import cherrypy
-from turbogears import testutil
-
-import bzrlib
-
-from loggerhead.controllers import Root
-
-def test_simple():
-    config = ConfigObj()
-    r = Root(config)
-    cherrypy.root = r
-    testutil.create_request('/')
-    assert 'loggerhead branches' in cherrypy.response.body[0]
-
-config_template = """
-[project]
-    [[branch]]
-        branch_name = 'branch'
-        folder = '%s'
-"""
-
-
-class TestWithSimpleTree(object):
-    def setUp(self):
-        self.old_bzrhome = bzrlib.osutils.set_or_unset_env('BZR_HOME', '')
-        self.bzrbranch = tempfile.mkdtemp()
-        branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
-            self.bzrbranch, force_new_tree=True)
-        tree = branch.bzrdir.open_workingtree()
-        f = open(os.path.join(self.bzrbranch, 'myfilename'), 'w')
-        self.filecontents = 'some\nmultiline\ndata'
-        try:
-            f.write(self.filecontents)
-        finally:
-            f.close()
-        tree.add('myfilename')
-        self.fileid = tree.path2id('myfilename')
-        self.msg = 'a very exciting commit message'
-        self.revid = tree.commit(message=self.msg)
-
-        ini = config_template%self.bzrbranch
-
-        config = ConfigObj(ini.splitlines())
-        cherrypy.root = Root(config)
-
-    def tearDown(self):
-        shutil.rmtree(self.bzrbranch)
-        bzrlib.osutils.set_or_unset_env('BZR_HOME', self.old_bzrhome)
-
-    # there are so i can run it with py.test and take advantage of the
-    # error reporting...
-    def setup_method(self, meth):
-        self.setUp()
-
-    def teardown_method(self, meth):
-        self.tearDown()
-
-    def test_index(self):
-        testutil.create_request('/')
-        link = '<a href="/project/branch">branch</a>'
-        assert link in cherrypy.response.body[0]
-
-    def test_changes(self):
-        testutil.create_request('/project/branch/changes')
-        assert self.msg in cherrypy.response.body[0]
-
-    def test_annotate(self):
-        testutil.create_request('/project/branch/annotate?'
-                                + 'file_id='+self.fileid)
-        for line in self.filecontents.splitlines():
-            assert line in cherrypy.response.body[0]
-
-    def test_inventory(self):
-        testutil.create_request('/project/branch/files')
-        assert 'myfilename' in cherrypy.response.body[0]
-

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2007-03-12 17:51:19 +0000
+++ loggerhead/util.py	2007-01-14 01:21:30 +0000
@@ -26,7 +26,6 @@
 import struct
 import sys
 import threading
-import time
 import traceback
 
 import turbogears
@@ -299,9 +298,9 @@
         params['start_revid'] = navigation.start_revid
         
     if navigation.prev_page_revid:
-        navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **get_context(**params))
+        navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **params)
     if navigation.next_page_revid:
-        navigation.next_page_url = navigation.branch.url([ navigation.scan_url, navigation.next_page_revid ], **get_context(**params))
+        navigation.next_page_url = navigation.branch.url([ navigation.scan_url, navigation.next_page_revid ], **params)
 
 
 def log_exception(log):
@@ -329,96 +328,13 @@
     @decorator
     def _decorator(unbound):
         def locked(self, *args, **kw):
+            #self.log.debug('-> %r lock %r', id(threading.currentThread()), debug_name)
             getattr(self, lockname).acquire()
             try:
                 return unbound(self, *args, **kw)
             finally:
                 getattr(self, lockname).release()
+                #self.log.debug('<- %r unlock %r', id(threading.currentThread()), debug_name)
         return locked
     return _decorator
 
-
-@decorator
-def strip_whitespace(f):
-    def _f(*a, **kw):
-        out = f(*a, **kw)
-        orig_len = len(out)
-        out = re.sub(r'\n\s+', '\n', out)
-        out = re.sub(r'[ \t]+', ' ', out)
-        out = re.sub(r'\s+\n', '\n', out)
-        new_len = len(out)
-        log.debug('Saved %sB (%d%%) by stripping whitespace.',
-                  human_size(orig_len - new_len),
-                  round(100.0 - float(new_len) * 100.0 / float(orig_len)))
-        return out
-    return _f
-
-
-@decorator
-def lsprof(f):
-    def _f(*a, **kw):
-        from loggerhead.lsprof import profile
-        import cPickle
-        z = time.time()
-        ret, stats = profile(f, *a, **kw)
-        log.debug('Finished profiled %s in %d msec.' % (f.__name__, int((time.time() - z) * 1000)))
-        stats.sort()
-        stats.freeze()
-        now = time.time()
-        msec = int(now * 1000) % 1000
-        timestr = time.strftime('%Y%m%d%H%M%S', time.localtime(now)) + ('%03d' % msec)
-        filename = f.__name__ + '-' + timestr + '.lsprof'
-        cPickle.dump(stats, open(filename, 'w'), 2)
-        return ret
-    return _f
-
-
-# just thinking out loud here...
-#
-# so, when browsing around, there are 5 pieces of context, most optional:
-#     - current revid
-#         current location along the navigation path (while browsing)
-#     - starting revid (start_revid)
-#         the current beginning of navigation (navigation continues back to
-#         the original revision) -- this may not be along the primary revision
-#         path since the user may have navigated into a branch
-#     - file_id
-#         if navigating the revisions that touched a file
-#     - q (query)
-#         if navigating the revisions that matched a search query
-#     - remember
-#         a previous revision to remember for future comparisons
-#
-# current revid is given on the url path.  the rest are optional components
-# in the url params.
-#
-# other transient things can be set:
-#     - compare_revid
-#         to compare one revision to another, on /revision only
-#     - sort
-#         for re-ordering an existing page by different sort
-
-t_context = threading.local()
-_valid = ('start_revid', 'file_id', 'q', 'remember', 'compare_revid', 'sort')
-
-
-def set_context(map):
-    t_context.map = dict((k, v) for (k, v) in map.iteritems() if k in _valid)
-
-
-def get_context(**overrides):
-    """
-    return a context map that may be overriden by specific values passed in,
-    but only contains keys from the list of valid context keys.
-    
-    if 'clear' is set, only the 'remember' context value will be added, and
-    all other context will be omitted.
-    """
-    map = dict()
-    if overrides.get('clear', False):
-        map['remember'] = t_context.map.get('remember', None)
-    else:
-        map.update(t_context.map)
-    overrides = dict((k, v) for (k, v) in overrides.iteritems() if k in _valid)
-    map.update(overrides)
-    return map

=== modified file 'push-website'
--- push-website	2007-01-24 18:43:51 +0000
+++ push-website	2006-12-29 21:51:12 +0000
@@ -3,5 +3,5 @@
 # this is only useful for robey.  it updates the public website.
 #
 
-rsync -avr homepage/ robey@green.lag.net:/web/loggerhead
+rsync -avr homepage/ robey@tavi.lag.net:/web/loggerhead
 

=== modified file 'setup.py'
--- setup.py	2007-03-26 06:09:27 +0000
+++ setup.py	2006-12-23 19:29:05 +0000
@@ -18,15 +18,14 @@
     
     install_requires = [
         "TurboGears >= 1.0b1",
-# for some reason, distutils can't find bzr.
-#        "bzr >= 0.13",
+        "bzr >= 0.13",
     ],
-    scripts = ["start-loggerhead.py", "stop-loggerhead.py"],
+    scripts = ["start-loggerhead.py"],
     zip_safe=False,
     packages=find_packages(),
     package_data = find_package_data(where='loggerhead',
                                      package='loggerhead'),
-#    data_files = find_package_data(where='loggerhead', package='loggerhead'),
+    data_files = find_package_data(where='loggerhead', package='loggerhead'),
     keywords = [
         'turbogears.app',
     ],

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2007-06-18 23:07:53 +0000
+++ start-loggerhead.py	2007-01-14 05:40:40 +0000
@@ -3,127 +3,77 @@
 import pkg_resources
 pkg_resources.require("TurboGears")
 
-import logging
 import os
-import sys
-from optparse import OptionParser
 
 import turbogears
 import cherrypy
 cherrypy.lowercase_api = True
 
-from loggerhead import daemon, release
-
-
-def make_handler(config, filename):
-    roll = config.get('log.roll', 'never')
-    if roll == 'daily':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'midnight', 0, 100)
-    elif roll == 'weekly':
-        h = logging.handlers.TimedRotatingFileHandler(filename, 'W0', 0, 100)
-    else:
-        h = logging.handlers.FileHandler(filename)
-    return h
-
-        
-def setup_logging(home, config, foreground):
-    # i hate that stupid logging config format, so just set up logging here.
-
-    log_folder = os.path.join(home, 'logs')
-    if not os.path.exists(log_folder):
-        os.mkdir(log_folder)
-    
-    f = logging.Formatter('%(levelname)-.3s [%(asctime)s.%(msecs)03d] %(name)s: %(message)s',
-                          '%Y%m%d-%H:%M:%S')
-    debug_log = make_handler(config, os.path.join(log_folder, 'debug.log'))
-    debug_log.setLevel(logging.DEBUG)
-    debug_log.setFormatter(f)
-    if foreground:
-        stdout_log = logging.StreamHandler(sys.stdout)
-        stdout_log.setLevel(logging.DEBUG)
-        stdout_log.setFormatter(f)
-    f = logging.Formatter('[%(asctime)s.%(msecs)03d] %(message)s',
-                          '%Y%m%d-%H:%M:%S')
-    access_log = make_handler(config, os.path.join(log_folder, 'access.log'))
-    access_log.setLevel(logging.INFO)
-    access_log.setFormatter(f)
-    
-    logging.getLogger('').addHandler(debug_log)
-    logging.getLogger('turbogears.access').addHandler(access_log)
-    logging.getLogger('turbogears.controllers').setLevel(logging.INFO)
-    
-    if foreground:
-        logging.getLogger('').addHandler(stdout_log)
-    
-
-
-def main():
-    parser = OptionParser(usage='usage: %prog [options]', version='%prog ' + release.version)
-    parser.add_option('-f', '--foreground', action='store_true', dest='foreground', default=False,
-                      help="run in the foreground; don't daemonize")
-    parser.add_option('-C', '--check', action='store_true', dest='check', default=False,
-                      help="only start if not already running (useful for cron jobs)")
-    options, args = parser.parse_args()
-    if len(args) > 0:
-        parser.error('No filename arguments are used, only options.')
-        
-        
-    home = os.path.realpath(os.path.dirname(__file__))
-    pidfile = os.path.join(home, 'loggerhead.pid')
-    
-    if options.check:
-        if daemon.is_running(pidfile):
-            sys.exit(0)
-        sys.stderr.write('Did not find okulo running in %r; restarting...\n' % (pidfile,))
-    
-    # read loggerhead config
-    
-    from configobj import ConfigObj
-    config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
-    extra_path = config.get('bzrpath', None)
-    if extra_path:
-        sys.path.insert(0, extra_path)
-    
-    turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
-    
-    potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
-    for key, keytype in potential_overrides:
-        value = config.get(key, None)
-        if value is not None:
-            value = keytype(value)
-            turbogears.config.update({ key: value })
-    
-    if not options.foreground:
-        sys.stderr.write('\n')
-        sys.stderr.write('Launching loggerhead into the background.\n')
-        sys.stderr.write('PID file: %s\n' % (pidfile,))
-        sys.stderr.write('\n')
-    
-        daemon.daemonize(pidfile, home)
-
-    setup_logging(home, config, foreground=options.foreground)
-        
-    log = logging.getLogger('loggerhead')
-    log.info('Starting up...')
-    
-    from loggerhead.controllers import Root
-    
-    Root = Root(config)
-    
-    # re-index every 6 hours
-    
-    index_freq = config.get('cache_rebuild_frequency', 6 * 3600)
-    turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
-    
-    try:
-        turbogears.start_server(Root)
-    finally:
-        log.info('Shutdown.')
-        try:
-            os.remove(pidfile)
-        except OSError:
-            pass
-
-
-if __name__ == '__main__':
-    main()
+import sys
+
+home = os.path.realpath(os.path.dirname(__file__))
+pidfile = os.path.join(home, 'loggerhead.pid')
+
+# read loggerhead config
+
+from configobj import ConfigObj
+config = sys._loggerhead_config = ConfigObj(os.path.join(home, 'loggerhead.conf'), encoding='utf-8')
+extra_path = config.get('bzrpath', None)
+if extra_path:
+    sys.path.insert(0, extra_path)
+
+turbogears.update_config(configfile="dev.cfg", modulename="loggerhead.config")
+
+potential_overrides = [ ('server.socket_port', int), ('server.webpath', str), ('server.thread_pool', int) ]
+for key, keytype in potential_overrides:
+    value = config.get(key, None)
+    if value is not None:
+        value = keytype(value)
+        turbogears.config.update({ key: value })
+
+
+sys.stderr.write('\n')
+sys.stderr.write('Launching loggerhead into the background.\n')
+sys.stderr.write('PID file: %s\n' % (pidfile,))
+sys.stderr.write('\n')
+
+from loggerhead.daemon import daemonize
+daemonize(pidfile, home)
+
+# i hate that stupid logging config format, so just set up logging here.
+import logging
+
+log_folder = os.path.join(home, 'logs')
+if not os.path.exists(log_folder):
+    os.mkdir(log_folder)
+
+f = logging.Formatter('%(levelname)-.3s [%(asctime)s.%(msecs)03d] %(name)s: %(message)s',
+                      '%Y%m%d-%H:%M:%S')
+debug_log = logging.FileHandler(os.path.join(log_folder, 'debug.log'))
+debug_log.setLevel(logging.DEBUG)
+debug_log.setFormatter(f)
+f = logging.Formatter('[%(asctime)s.%(msecs)03d] %(message)s',
+                      '%Y%m%d-%H:%M:%S')
+access_log = logging.FileHandler(os.path.join(log_folder, 'access.log'))
+access_log.setLevel(logging.INFO)
+access_log.setFormatter(f)
+
+logging.getLogger('').addHandler(debug_log)
+logging.getLogger('turbogears.access').addHandler(access_log)
+logging.getLogger('turbogears.controllers').setLevel(logging.INFO)
+
+log = logging.getLogger('loggerhead')
+log.info('Starting up...')
+
+from loggerhead.controllers import Root
+
+# re-index every 6 hours
+index_freq = 6 * 3600
+turbogears.scheduler.add_interval_task(initialdelay=1, interval=index_freq, action=Root._check_rebuild)
+
+try:
+    turbogears.start_server(Root)
+finally:
+    log.info('Shutdown.')
+    os.remove(pidfile)
+

=== modified file 'stop-loggerhead.py'
--- stop-loggerhead.py	2007-01-24 19:17:25 +0000
+++ stop-loggerhead.py	2007-01-14 05:40:40 +0000
@@ -24,7 +24,7 @@
     sys.exit(1)
 
 print
-print 'Shutting down previous server @ pid %d.' % (pid,)
+print 'Shutting down previus server @ pid %d.' % (pid,)
 print
 
 import signal

